﻿Imports System
Imports System.Collections.Generic
Imports System.Text

Namespace MsdnMag.Exchange.PushNotificationClient
    Friend NotInheritable Class PropertyParser
        ' Fields
        Private Shared _fieldSeperator As Char = ";"c
        Private Shared _valueSeperator As Char = "="c

        ' Methods
        Private Sub New()
        End Sub
        Friend Shared Function GetTable(ByVal propertyList As String) As Dictionary(Of String, String)
            Dim dictionary As Dictionary(Of String, String) = Nothing
            If propertyList IsNot Nothing Then
                dictionary = New Dictionary(Of String, String)(StringComparer.OrdinalIgnoreCase)
                Dim str As String = String.Empty
                Dim strArray() As String = propertyList.Split(New Char() {_fieldSeperator}, StringSplitOptions.RemoveEmptyEntries)
                If strArray Is Nothing Then
                    Return dictionary
                End If
                For Each str2 In strArray
                    Dim index As Integer = str2.IndexOf(_valueSeperator)
                    If index <> -1 Then
                        Dim str3 As String = str2.Substring(0, index).Trim()
                        Dim str4 As String = str2.Substring(index + 1).Trim()
                        If (str3.Length = 0) OrElse (str4.Length = 0) Then
                            Throw New Exception("Invalid WorkItem Property.")
                        End If
                        str = str3
                        dictionary(str3) = str4
                    Else
                        If String.IsNullOrEmpty(str) Then
                            Throw New Exception("Invalid WorkItem Property.")
                        End If
                        dictionary(str) = New StringBuilder(dictionary(str)).Append(_fieldSeperator).Append(str2.Trim()).ToString()
                    End If
                Next str2
            End If
            Return dictionary
        End Function
    End Class
End Namespace